package jflowchart.engine.arithmetics;

public abstract class ComparableBinaryOperation extends BinaryOperation {

	private ComparableOperand op1;
	private ComparableOperand op2;
	
	protected ComparableBinaryOperation() {
		super();
		op1 = null;
		op2 = null;
	}
	
	public void setFirstOperand(ComparableOperand o) throws IncompatibleDataTypesException {
		try {
			super.setFirstOperand(o);
			op1 = o;
		} catch (IncompatibleDataTypesException e) {
			throw e;
		}
	}
	
	public void setSecondOperand(ComparableOperand o) throws IncompatibleDataTypesException {
		try {
			super.setSecondOperand(o);
			op2 = o;
		} catch (IncompatibleDataTypesException e) {
			throw e;
		}
	}
	
	public ComparableOperand getFirstOperand() {
		return op1;
	}
	
	public ComparableOperand getSecondOperand() {
		return op2;
	}
	
	public boolean usable() {
		return (super.usable() && (op1 != null) && (op2 != null));
	}
	
}
