package jflowchart.engine.arithmetics;

import java.util.LinkedList;

import jflowchart.engine.common.Const;
import jflowchart.engine.xml.XMLWriter;
import jflowchart.engine.xml.XMLWriterException;

public class ComparableValue extends Value implements ComparableOperand {
	
	@SuppressWarnings("rawtypes")
	private Comparable innerValue;
	
	@SuppressWarnings("rawtypes")
	protected ComparableValue(Comparable v, boolean num) {
		super(v,true, num);
		innerValue = v;
	}
	
	@SuppressWarnings("rawtypes")
	public ComparableValue(Comparable v) {
		super(v,true, false);
		innerValue = v;
	}
	
	public ComparableValue getValue() {
		return this;
	}
	
	public String print() {
		if (innerValue.getClass().equals(String.class))
			return "\"" + super.print() + "\"";
		else return super.print();
	}

	@SuppressWarnings("unchecked")
	@Override
	public int compareTo(ComparableOperand o) {
		return innerValue.compareTo(o.getInnerValue());
	}

	@Override
	public String copy() {
		return Const.COMPARABLE_VALUE_CODE + Const.SPACE + innerValue.toString();
	}

	@Override
	public int paste(String[] data, int pointer) {
		if (! data[pointer].equals(Const.COMPARABLE_VALUE_CODE))
			return Const.PASTE_ERROR;
		else return pointer + 2;
	}

	@SuppressWarnings("rawtypes")
	@Override
	public Comparable getInnerValue() {
		return innerValue;
	}

	@Override
	public boolean hasFixValue() {
		return true;
	}

	@Override
	public boolean contains(Variable v) {
		return false;
	}

	@Override
	public void save(XMLWriter h) throws XMLWriterException {
		h.writeValue(Const.COMPARABLE_VALUE_CODE, innerValue.toString());
	}

	@Override
	public void collectVariables(LinkedList<Variable> vars) {
	}
	
}
