package jflowchart.engine.arithmetics;

public abstract class Value implements Operand {
	
	private Object value;
	private boolean comparableFlag;
	private boolean numberFlag;
	
	protected Value(Object v, boolean comp, boolean num) {
		value = v;
		comparableFlag = comp;
		numberFlag = num;
	}

	@Override
	public Value getValue() {
		return this;
	}

	@SuppressWarnings("rawtypes")
	@Override
	public Class getDataType() {
		return value.getClass();
	}
	
	public String print() {
		return value.toString();
	}

	@Override
	public boolean isValue() {
		return true;
	}

	@Override
	public boolean isVariable() {
		return false;
	}

	@Override
	public boolean isExpression() {
		return false;
	}

	@Override
	public boolean isComparable() {
		return comparableFlag;
	}

	@Override
	public boolean isNumber() {
		return numberFlag;
	}

	@Override
	public boolean isUserSet() {
		return false;
	}
	
	@Override
	public boolean isIterating() {
		return false;
	}

}
