package jflowchart.engine.history;

import java.util.LinkedList;

import jflowchart.ui.canvas.FlowChartCanvas;
import jflowchart.ui.canvas.graphnodes.GraphNode;


public class AddingAction extends GeneralAction {

	private LinkedList<GraphNode> nodes;
	
	public AddingAction(FlowChartCanvas c) {
		super(c);
		nodes = new LinkedList<GraphNode>();
	}
	
	public void addAddingNode(GraphNode n) {
		nodes.add(n);
	}
	
	@Override
	public void undo() {
		for (int i = 0; i < nodes.size(); i++) 
			canvas.removeNode(nodes.get(i));
	}

	@Override
	public void redo() {
		for (int i = 0; i < nodes.size(); i++) 
			canvas.addNode(nodes.get(i));
	}

}
