package jflowchart.engine.history;

import java.util.LinkedList;

import jflowchart.engine.nodes.AssistantConnectPoint;
import jflowchart.engine.nodes.ConnectPoint;
import jflowchart.ui.canvas.FlowChartCanvas;

public class AddingConnectionAction extends GeneralAction {
	
	private ConnectPoint from;
	private ConnectPoint to;
	private LinkedList<AssistantConnectPoint> path;

	public AddingConnectionAction(FlowChartCanvas c, ConnectPoint from, LinkedList<AssistantConnectPoint> path, ConnectPoint to) {
		super(c);
		this.from = from;
		this.to = to;
		this.path = new LinkedList<AssistantConnectPoint>();
		for (AssistantConnectPoint a : path)
			this.path.add(a);
	}

	@Override
	public void undo() {
		canvas.removeConnection(from, to);
	}

	@Override
	public void redo() {
		canvas.addConnection(from, path, to);
	}

}
