package jflowchart.engine.history;

import jflowchart.engine.arithmetics.Assignment;
import jflowchart.engine.arithmetics.IncompatibleDataTypesException;
import jflowchart.engine.arithmetics.Operand;
import jflowchart.engine.arithmetics.Variable;
import jflowchart.ui.canvas.FlowChartCanvas;

public class EditingAssignmentAction extends GeneralAction {

	private Assignment assignment;
	
	private Variable oldVariable;
	private Operand oldOperand;
	
	private Variable newVariable;
	private Operand newOperand;
	
	public EditingAssignmentAction(FlowChartCanvas c, Assignment a) {
		super(c);
		assignment = a;
		oldVariable = assignment.getFirstOperand();
		oldOperand = assignment.getSecondOperand();
	}
	
	public void recordNewData() {
		newVariable = assignment.getFirstOperand();
		newOperand = assignment.getSecondOperand();
	}
	
	private void writeData(Variable v, Operand o) {
		try {
			assignment.setFirstOperand(v);
			assignment.setSecondOperand(o);
		} catch (IncompatibleDataTypesException e) {}
		canvas.getMainShell().setSavedFlag();
		canvas.updateSemaphore();
		canvas.redraw();
	}
	
	@Override
	public void undo() {
		writeData(oldVariable, oldOperand);
	}

	@Override
	public void redo() {
		writeData(newVariable, newOperand);
	}

}
