package jflowchart.engine.history;

import java.util.LinkedList;

import jflowchart.engine.nodes.AssistantConnectPoint;
import jflowchart.engine.nodes.ConnectPoint;
import jflowchart.ui.canvas.FlowChartCanvas;

public class EditingConnectionAction extends GeneralAction {
	
	private ConnectPoint from;
	private ConnectPoint origTo;
	private ConnectPoint newTo;
	
	private LinkedList<AssistantConnectPoint> oldPath;
	private LinkedList<AssistantConnectPoint> newPath;

	public EditingConnectionAction(FlowChartCanvas c, ConnectPoint from, LinkedList<AssistantConnectPoint> oldPath, LinkedList<AssistantConnectPoint> newPath, ConnectPoint origTo, ConnectPoint newTo) {
		
		super(c);
		
		this.from = from;
		this.origTo = origTo;
		this.newTo = newTo;
		
		this.oldPath = new LinkedList<AssistantConnectPoint>();
		for (AssistantConnectPoint a : oldPath)
			this.oldPath.add(a);
		
		this.newPath = new LinkedList<AssistantConnectPoint>();
		for (AssistantConnectPoint a : newPath)
			this.newPath.add(a);
		
	}

	@Override
	public void undo() {
		canvas.removeConnection(from, newTo);
		canvas.addConnection(from, oldPath, origTo);
		canvas.updateSemaphore();
		canvas.redraw();
	}

	@Override
	public void redo() {
		canvas.removeConnection(from, origTo);
		canvas.addConnection(from, newPath, newTo);
		canvas.updateSemaphore();
		canvas.redraw();
	}

}
