package jflowchart.engine.history;

import jflowchart.engine.arithmetics.Variable;
import jflowchart.engine.nodes.InputOutputNode;
import jflowchart.ui.canvas.FlowChartCanvas;

public class EditingInputOutputAction extends GeneralAction {

	private InputOutputNode node;
	private Variable oldVariable;
	private Variable newVariable;
	
	public EditingInputOutputAction(FlowChartCanvas c, InputOutputNode n) {
		super(c);
		node = n;
		oldVariable = n.getVariable();
	}

	@Override
	public void recordNewData() {
		newVariable = node.getVariable();
	}
	
	private void writeData(Variable v) {
		node.setVariable(v);
		canvas.getMainShell().setSavedFlag();
		canvas.updateSemaphore();
		canvas.redraw();
	}

	@Override
	public void undo() {
		writeData(oldVariable);
	}

	@Override
	public void redo() {
		writeData(newVariable);
	}

}
