package jflowchart.engine.history;

import jflowchart.engine.arithmetics.Assignment;
import jflowchart.engine.arithmetics.Comparison;
import jflowchart.ui.canvas.FlowChartCanvas;

public class EditingPreparationAction extends GeneralAction {

	private EditingConditionAction condAction;
	private EditingAssignmentAction assignAction;
	
	public EditingPreparationAction(FlowChartCanvas c, Comparison cond, Assignment a) {
		super(c);
		condAction = new EditingConditionAction(c, cond);
		assignAction = new EditingAssignmentAction(c, a);
	}

	@Override
	public void undo() {
		condAction.undo();
		assignAction.undo();
	}

	@Override
	public void redo() {
		condAction.redo();
		assignAction.redo();
	}

	@Override
	public void recordNewData() {
		condAction.recordNewData();
		assignAction.recordNewData();
	}

}
