package jflowchart.engine.history;

import java.util.LinkedList;

import jflowchart.ui.canvas.FlowChartCanvas;
import jflowchart.ui.canvas.graphnodes.GraphNode;


public class MovingAction extends GeneralAction {

	private int fromX;
	private int fromY;
	private int toX;
	private int toY;
	
	private LinkedList<GraphNode> nodes;
	
	public MovingAction(FlowChartCanvas c, int x, int y) {
		super(c);
		fromX = x;
		fromY = y;
		toX = 0;
		toY = 0;
		nodes = new LinkedList<GraphNode>();
	}
	
	public void addMovingNode(GraphNode n) {
		nodes.add(n);
	}
	
	public void updateDestination(int x, int y) {
		toX = x;
		toY = y;
	}

	@Override
	public void undo() {
		int dx = fromX - toX;
		int dy = fromY - toY;
		for (int i = 0; i < nodes.size(); i++)
			canvas.moveNode(nodes.get(i), dx, dy);
	}

	@Override
	public void redo() {
		int dx = toX - fromX;
		int dy = toY - fromY;
		for (int i = 0; i < nodes.size(); i++)
			canvas.moveNode(nodes.get(i), dx, dy);
	}

	@Override
	public void recordNewData() {
	}

}
