package jflowchart.engine.history;

import java.util.LinkedList;

import jflowchart.engine.nodes.AssistantConnectPoint;
import jflowchart.engine.nodes.ConnectPoint;
import jflowchart.ui.canvas.FlowChartCanvas;
import jflowchart.ui.canvas.graphnodes.GraphNode;

public class RemovingAction extends GeneralAction {
	
	private LinkedList<GraphNode> nodes;
	private LinkedList<ConnectPoint[]> connections;
	private LinkedList<LinkedList<AssistantConnectPoint>> paths;
	
	public RemovingAction(FlowChartCanvas c) {
		super(c);
		nodes = new LinkedList<GraphNode>();
		connections = new LinkedList<ConnectPoint[]>();
		paths = new LinkedList<LinkedList<AssistantConnectPoint>>();
	}
	
	public void addRemovedNode(GraphNode n) {
		nodes.add(n);
	}
	
	public void addConnection(ConnectPoint from, LinkedList<AssistantConnectPoint> path, ConnectPoint to) {
		connections.add(new ConnectPoint[] {from, to});
		paths.add(path);
	}

	@Override
	public void undo() {
		for (GraphNode n : nodes) 
			canvas.addNode(n);
		for (int i = 0; i < connections.size(); i++) {
			ConnectPoint[] connection = connections.get(i);
			canvas.addConnection(connection[0], paths.get(i), connection[1]);
		}
	}

	@Override
	public void redo() {
		for (int i = 0; i < nodes.size(); i++)
			canvas.removeNode(nodes.get(i));
	}

}
