package jflowchart.engine.history;

import jflowchart.ui.canvas.FlowChartCanvas;

public class ResizingAction extends GeneralAction {

	private int oldWidth;
	private int oldHeight;
	private int newWidth;
	private int newHeight;
	
	public ResizingAction(FlowChartCanvas c, int width, int height) {
		super(c);
		oldWidth = width;
		oldHeight = height;
		newWidth = 0;
		newHeight = 0;
	}
	
	public void setNewSize(int width, int height) {
		newWidth = width;
		newHeight = height;
	}

	@Override
	public void undo() {
		canvas.setSize(oldWidth, oldHeight);
	}

	@Override
	public void redo() {
		canvas.setSize(newWidth, newHeight);
	}

	@Override
	public void recordNewData() {
	}

}
