package jflowchart.ui.canvas;

import org.eclipse.swt.widgets.Display;

public class CanvasPlayer {
	
	private int delay;
	
	private Display display;
	private FlowChartCanvas canvas;
	private Runnable runnable;
	
	public CanvasPlayer(Display d, FlowChartCanvas c) {
		delay = 1000;
		display = d;
		canvas = c;
		runnable = new Runnable() {
			public void run() {
				canvas.animate();
				display.timerExec(delay, this);
			}
		};
	}
	
	public void play() {
		display.timerExec(delay, runnable);
	}
	
	public void stop() {
		display.timerExec(-1, runnable);
	}

}
