package jflowchart.ui.canvas.graphnodes;

import jflowchart.engine.common.Const;
import jflowchart.engine.nodes.EndNode;
import jflowchart.ui.canvas.FlowChartCanvas;

import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;

public class EndGraphNode extends EndNode implements GraphNode {
	
	private FlowChartCanvas canvas;
	
	private void init(FlowChartCanvas c) {
		canvas = c;
	}

	public EndGraphNode(FlowChartCanvas c, boolean ghost) {
		super(ghost);
		init(c);
	}
	
	public EndGraphNode(FlowChartCanvas c, int x, int y, boolean ghost) {
		super(x, y, ghost);
		init(c);
	}

	@Override
	public void setContextMenu(boolean multipleSelection) {
		canvas.setNodeContextMenu();
	}

	@Override
	public void draw(GC gc) {
		Image endImg = new Image(canvas.getDisplay(), getClass().getResourceAsStream("/flowchartSymbols/csnIso5807/startStop.png"));
		gc.drawImage(endImg, 0, 0, endImg.getBounds().width, endImg.getBounds().height, getWestBorder(), getNorthBorder(), width, height);
		endImg.dispose();
		if (hasBreakpoint) canvas.drawBreakpoint(connectPoints[0].getX(), connectPoints[0].getY(), gc);
		Font defFont = gc.getFont();
		FontData[] fd = defFont.getFontData();
		Font font = new Font(canvas.getDisplay(), fd[0].getName(), Const.DEFAULT_DRAWING_FONT_HEIGHT, fd[0].getStyle());
		gc.setFont(font);
		gc.drawText(Const.END_NODE_LABEL, positionX - gc.getFontMetrics().getAverageCharWidth() * Const.END_NODE_LABEL.length() / 2, positionY - gc.getFontMetrics().getHeight() / 2, true);
		gc.setFont(defFont);
		font.dispose();
	}

	@Override
	public FlowChartCanvas getCanvas() {
		return canvas;
	}

}
