package jflowchart.ui.windows;

import jflowchart.engine.common.Language;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import swing2swt.layout.BorderLayout;
import swing2swt.layout.FlowLayout;

public class UnsavedChangesDialog extends Shell {
	
	private UnsavedChangesOption result = UnsavedChangesOption.CANCEL;
	private Language lang;

	public UnsavedChangesDialog(Shell parent, Language l) {
		super(parent, SWT.CLOSE | SWT.TITLE | SWT.APPLICATION_MODAL);
		lang = l;
		createContents();
	}
	
	public UnsavedChangesOption getResult() {
		this.open();
		this.layout();
		Display display = getParent().getDisplay();
		while (!this.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
		return result;
	}

	/**
	 * Create contents of the shell.
	 */
	protected void createContents() {
		
		setText(lang.unsavedChanges);
		setSize(428, 131);
		
		setLayout(new BorderLayout(0, 0));
		
		Composite buttonsComposite = new Composite(this, SWT.NONE);
		buttonsComposite.setLayoutData(BorderLayout.SOUTH);
		buttonsComposite.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 5));
		
		Composite groupComposite = new Composite(buttonsComposite, SWT.NONE);
		groupComposite.setLayout(new RowLayout(SWT.HORIZONTAL));
		
		Button btnSave = new Button(groupComposite, SWT.NONE);
		btnSave.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				result = UnsavedChangesOption.SAVE;
				dispose();
			}
		});
		btnSave.setText(lang.save);
		
		Button btnDiscard = new Button(groupComposite, SWT.NONE);
		btnDiscard.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				result = UnsavedChangesOption.DISCARD;
				dispose();
			}
		});
		btnDiscard.setText(lang.discard);
		
		Button btnCancel = new Button(groupComposite, SWT.NONE);
		btnCancel.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				result = UnsavedChangesOption.CANCEL;
				dispose();
			}
		});
		btnCancel.setSelection(true);
		btnCancel.setText(lang.cancel);
		
		Composite messageComposite = new Composite(this, SWT.NONE);
		messageComposite.setLayoutData(BorderLayout.CENTER);
		messageComposite.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 5));
		
		Label lblMessage = new Label(messageComposite, SWT.NONE);
		lblMessage.setAlignment(SWT.CENTER);
		lblMessage.setText(lang.unsavedChangesMessage);

	}

	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}

}
